/* 5sec Validator
 * (c) Web factory Ltd, 2011
 * www.webfactoryltd.com
 */

validator_urls = [];
validator_urls_nb = 0;
progressbar_status = 0;

jQuery(document).ready(function($) {
  $('.chk-url').removeAttr('checked');
  $('#chk-all').removeAttr('checked');
  $('#validator-table .chk-url').removeAttr('checked')
                                .removeAttr('disabled');
  $('#validator-table input').removeAttr('disabled');
  update_validate_button();

  $('#chk-all').change(function() {
    if($(this).attr('checked') == 'checked') {
      $('#validator-table .chk-url:visible').attr('checked', 'checked');
    } else {
      $('#validator-table .chk-url:visible').removeAttr('checked');
    }
    update_validate_button();
  }); // chk-all

  $('.chk-url').change(function() {
    update_validate_button();
  });

  $('#validate-all').click(function(event) {
    $(this).prop('disabled', true);
    validator_get_urls();
    validator_run();

    return false;
  }); // validate all click

  $('#validate-search').keypress(function(event){
    if (event.which == 13 ) {
      $('#validate-search-btn').click();
      return false;
    }
  });

  $('#validate-search-btn').click(function(event) {
    query = $('#validate-search').val();

    $('#validator-table .chk-url').each(function(ind, elem) {
      tmp = $(elem).val();
      if (tmp.search(eval('/' + query + '/i')) == -1) {
        $(elem).parents('tr').hide();
      } else {
        $(elem).parents('tr').show();
      }
    });
    update_validate_button();
  }); // search click

  $('a.toggle').live('click', function() {
    $(this).siblings('.lightbox-details').toggle();
    $(this).siblings('.css-details-container').toggle();
    $(this).toggleClass('toggle-minus');
  });

  $('input.details-css, input.details-html').livequery(function() {
                                                $(this).fancybox({ autoDimensions: true,
                                                                   autoScale: true,
                                                                   padding: 25,
                                                                   scrolling: 'no',
                                                                   centerOnScroll: true,
                                                                   ajax:{type: 'POST'} })
  });
}); // document ready

function validator_run() {
  if (!validator_urls_nb) {
    alert('Please select at least one URL to validate.');
    return false;
  }

  jQuery('#validate-all').val('Validating, please wait ...');
  jQuery('#validator-progress').show().progressbar({value: 0});
  jQuery('#percentText').html('0%');

  for (i = 0; i < validator_urls_nb; i++) {
    jQuery('#' + validator_urls[i].row_id).css('background-color', '#ddebf8')
                                          .css('opacity', '0.3')
                                          .css('cursor', 'wait')
    jQuery('#' + validator_urls[i].row_id + ' input').attr('disabled', 'disabled');
  } // for

  validator_run_single(0);
  validator_run_single(1);
} // validator_run

function validator_run_single(mode) {
  for (i = mode; i < validator_urls_nb; i+=2) {
    if (validator_urls[i].done == false) {
      break;
    }
  } // for
  if (i >= validator_urls_nb) {
    return false;
  }
  validator_urls[i].done = true;

  var data = { action: 'validator_validate_url',
               url: validator_urls[i].url,
               row_id: validator_urls[i].row_id};
  jQuery.post(ajaxurl, data, function(response) {
      jQuery('#' + response.row_id).css('opacity', '1')
                                   .css('cursor', 'auto')
                                   .css('background-color', '#F9F9F9');
      jQuery('#' + response.row_id + ' input').removeAttr('disabled');
      jQuery('#' + response.row_id + ' .bad-response').remove();

      if (response.fail == false) {
        jQuery('#' + response.row_id + ' .errors_html').html(response.html_errors);
        jQuery('#' + response.row_id + ' .warnings_html').html(response.html_warnings);
        jQuery('#' + response.row_id + ' .errors_css').html(response.css_errors);
        jQuery('#' + response.row_id + ' .warnings_css').html(response.css_warnings);
        jQuery('#' + response.row_id + ' .last').html(response.last);
        if (response.html_errors) {
          jQuery('#' + response.row_id + ' .details_html').html('<input type="button" class="button-secondary details-html" value="Details" href="admin-ajax.php?action=validator_details_html&url=' + response.url + '" title="HTML errors details for: ' + response.url + '" />');
        } else {
          jQuery('#' + response.row_id + ' .details_html').html('<span class="good">Valid!</span>');
        }
        if (response.css_errors || response.css_warnings) {
          jQuery('#' + response.row_id + ' .details_css').html('<input type="button" class="button-secondary details-css" value="Details" href="admin-ajax.php?action=validator_details_css&url=' + response.url + '" title="CSS errors/warnings details for: ' + response.url + '" />');
        } else {
          jQuery('#' + response.row_id + ' .details_css').html('<span class="good">Valid!</span>');
        }

      } else {
        jQuery('#' + response.row_id + ' .errors_html').html('n/a');
        jQuery('#' + response.row_id + ' .warnings_html').html('n/a');
        jQuery('#' + response.row_id + ' .errors_css').html('n/a');
        jQuery('#' + response.row_id + ' .warnings_css').html('n/a');
        jQuery('#' + response.row_id + ' .last').html(response.last);
        jQuery('#' + response.row_id + ' .details_html').html('');
        jQuery('#' + response.row_id + ' .details_css').html('');
        jQuery('#' + response.row_id + ' .url').append('<span class="bad-response">Bad response from W3C validator.</span>');
      }

     validator_progressBar_move();
     validator_run_single(mode);
  }, 'json');
} // validator_run_single

// progress bar control
function validator_progressBar_move() {
  progressbar_status++;
  var percent = Math.round(progressbar_status / validator_urls_nb * 100);

  jQuery("#validator-progress").progressbar({ value: percent});
  jQuery('#percentText').html(percent + '%');

  if (percent == 100) {
    jQuery('#validator-progress').hide();
    update_validate_button();
  }
} // validator_progressBar_move

function validator_get_urls() {
  validator_urls = [];
  validator_urls_nb = 0;
  progressbar_status = 0;

  jQuery('#validator-table .chk-url:checked:visible').each(function(index, chk) {
    tmp = {'done': false, 'url': jQuery(chk).val(), 'row_id': jQuery(chk).parents('tr').attr('id')};
    validator_urls.push(tmp);
  });

  validator_urls_nb = validator_urls.length;
} // validator_get_urls

function update_validate_button() {
  jQuery('#validate-all').removeAttr('disabled');

  var cnt = jQuery('.chk-url:checked:visible').length;
  if (cnt) {
    jQuery('#validate-all').val('Validate selected URLs (' + cnt + ')');
  } else {
    jQuery('#validate-all').val('Validate selected URLs');
  }
} // update_validate_button